package net.fishol.servlet;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.PrintWriter;
import java.io.StreamCorruptedException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import edu.umich.popcup.util.Image;
import edu.umich.popcup.util.Model3D;
import edu.umich.popcup.util.Ply;

/**
 * Servlet implementation class ResponseTest
 */
public class ResponseTest extends HttpServlet {
	private static final long serialVersionUID = 1L;
	
	public static final String RES_DIR = "/res";
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public ResponseTest() {
        super();
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		//sendTextResponse(request, response);
		//receiveImage(request, response);
		doPost(request, response);
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		//sendTextResponse(request, response);
		receiveImage(request, response);
	}
	
	private void receiveImage(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		//ServletInputStream sis = request.getInputStream();
		/*BufferedInputStream buffer = new BufferedInputStream(sis);
		String imagePath = getServletContext().getRealPath(RES_DIR + "/test_image.jpg");
		FileOutputStream fos = new FileOutputStream(imagePath);
		int readByte = 0;
		while ((readByte = buffer.read()) != -1) {
			fos.write(readByte);
		}
	//	fos.flush();
		fos.close();*/
		String imagePath = getServletContext().getRealPath(RES_DIR + "/test_image.jpg");
		Image image = null;

		ObjectInputStream ois = new ObjectInputStream(request.getInputStream());
		try {
			image = (Image)ois.readObject();
			
			// Write the image file to the disk
			FileOutputStream fos = new FileOutputStream(imagePath);
			fos.write(image.getImageData());
			fos.close();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		} catch (StreamCorruptedException e) {
			e.printStackTrace();
		}
		
		
		/**
		 * Code for the system processing the image here.
		 */
		
		
		String plyPath = getServletContext().getRealPath(RES_DIR + "/ply_res/mouse_1.ply");
		Ply ply = new Ply(plyPath);
		ply.readFile();
		
		Model3D model = new Model3D();
		model.addPly(ply);
		model.setPose(image.getPose());
		model.setCategory(image.getCategory());
		
		ObjectOutputStream oos = new ObjectOutputStream(response.getOutputStream());
		oos.writeObject(model);
		oos.flush();
		oos.close();
		
		/*PrintWriter out = response.getWriter();
		out.print(imagePath);
		if (image != null) {
			out.print("\tPose: "+ image.getPose());
			out.print("\tCategory: " + image.getCategory());
		} else {
			out.println("Error: image is not received");
		}*/
		
	}
	
	@SuppressWarnings("unused")
	private void sendTextResponse(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		PrintWriter out = response.getWriter();
		out.println("Hello");
	}

}
